
restart;
intCheb := proc(startpoly, n, c)
local F, LCM, Lower, N, SimpTable, Upper, approxresbound, b1, b2, b3, changed, congs,
      eps, i, ind, innerTable, linpolyinfo,linpolys, newlowup, pass, polyroots, polys,
      r, rbs, resIs0, resbound, sols, steps, u;
    Digits := max(20, n);
    polys := [x*(1 - x), (2*x - 1)^2, 5*x^2 - 5*x + 1,
              6*x^2 - 6*x + 1, 29*x^4 - 58*x^3 + 40*x^2 - 11*x + 1,
              (13*x^3 - 20*x^2 + 9*x - 1)*(13*x^3 - 19*x^2 + 8*x - 1),
              (31*x^4 - 63*x^3 + 44*x^2 - 12*x + 1)*(31*x^4 - 61*x^3 + 41*x^2 - 11*x + 1),
              941*x^8-3764*x^7+6349*x^6-5873*x^5+3243*x^4-1089*x^3+216*x^2-23*x+1];
    polyroots := [[0, 1], [0.5],seq([fsolve(polys[i])], i = 3 .. nops(polys))];
    eps := 1/1000000*c;
    if startpoly = 1 then
        r := 0;
        while evalf(c*sqrt(2*r+1)*(n+r+1)!/((n-r)!*(2*r+1)!))< 1 do r:=r+1 end do;
        F := (x*(1 - x))^r;
        if n mod 2 = 1 then F := F*(2*x - 1) end if
    else F := startpoly
    end if;
    if nargs = 4 then F := F*args[4] end if;
    N := 1/2*n - 1/2*degree(F) + 1;
    print(F, N - 1);
    u := unapply(1/2 - 1/2*sqrt(1 - 4*x), x);
    changed := true;
    while changed and 1 < N do
        if not has(F, 2*x - 1) and
        abs(2^(n - degree(F))*c*subs(x = 1/2, 1/F)) < 1 then
            print("adding the following factor", (2*x - 1)^2);
            F := F*(2*x - 1)^2;
            N := N - 1
        end if;
        for i from 3 to nops(polys) do
            if (type(polys[i], `+`) and not has(F, polys[i])
            or type(polys[i], `*`) and not has(F, op(1, polys[i]))) and
              abs(lcoeff(polys[i])^(n - degree(F))*c^degree(polys[i])
              *`*`(seq(subs(x=polyroots[i][j], 1/F),j=1..nops(polyroots[i]))))<0.999 then
                print("adding the following factor", polys[i]);
                F := F*polys[i];
                N := N - 1/2*degree(polys[i])
end if end do;
        changed := false;
        innerTable := table();
        SimpTable := table();
        linpolyinfo := getlinpolyinfo(F, N, c, eps,[0, 1/4, 1/5, 1/6],
                         [infinity, infinity, infinity, infinity], false);
        congs := linpolyinfo[1];  Upper := linpolyinfo[2];  Lower := linpolyinfo[3];
        LCM := linpolyinfo[4];    steps := linpolyinfo[5];  sols := linpolyinfo[6];
        linpolys := linpolyinfo[7];
        for pass to 2 do
            print("checking factor x*(1-x)");
            newlowup := applySimp(1, 1, LCM, indices, sols, F,N, c, eps, Lower, Upper,
                             steps, addressof(SimpTable), addressof(innerTable), true);
            if newlowup[2] = 0 then
                F := F*x*(1 - x); N := N - 1; changed := true
            else
                Lower[1] := -newlowup[2]; Upper[1] := newlowup[2]
            end if;
            if not changed and 1 < N then
                print("checking factor (2x-1)");
                newlowup := applySimp(1, 2, LCM, indices, sols, F, N, c, eps, Lower, Upper,
                                 steps, addressof(SimpTable), addressof(innerTable), true);
                if newlowup[2] = 0 then
                    F := F*(2*x - 1)^2; N := N - 1; changed := true
                else
                    Lower[2] := -newlowup[2]; Upper[2] := newlowup[2]
                end if
            end if;
            if not changed and 2 < N then
                print("checking factor (5*x^2-5*x+1)");
                newlowup := applySimp(1, 3, LCM, indices, sols, F, N, c, eps, Lower, Upper,
                                 steps, addressof(SimpTable), addressof(innerTable), true);
                if newlowup[2] = 0 then
                    F := F*(5*x^2 - 5*x + 1); N := N - 1; changed := true
                else
                    Lower[3] := -newlowup[2]; Upper[3] := newlowup[2]
end if end if;
            if not changed and 3 < N and pass = 1 then
                print("checking factor (6*x^2-6*x+1)");
                newlowup := applySimp(1, 4, LCM, indices, sols, F, N, c, eps, Lower, Upper,
                                 steps, addressof(SimpTable), addressof(innerTable), true);
                if newlowup[2] = 0 then
                    F := F*(6*x^2 - 6*x + 1); N := N - 1; changed := true
                else
                    Lower[4] := -newlowup[2]; Upper[4] := newlowup[2]
end if end if;
            if changed then pass := 2 end if
        end do;
        if not changed and 13 < N then
            rbs := [Upper[1], Upper[2], Upper[3], Upper[4], infinity];
            print("checking factor 29*x^4-58*x^3+40*x^2-11*x+1");
            innerTable := table();
            SimpTable := table();
            linpolyinfo := getlinpolyinfo(F, N, c, eps,[0, 1/4, 1/5, 1/6, 987/4325],
                                  [rbs[1], rbs[2], rbs[3], rbs[4], infinity], false);
            congs := linpolyinfo[1];  Upper := linpolyinfo[2];  Lower := linpolyinfo[3];
            LCM := linpolyinfo[4];    steps := linpolyinfo[5];  sols := linpolyinfo[6];
            linpolys := linpolyinfo[7];
            b1 := applySimp(1, 5, LCM, indices, sols, F, N, c, eps, Lower, Upper, steps,
                                     addressof(SimpTable), addressof(innerTable), true);
            innerTable := table();
            SimpTable := table();
            linpolyinfo := getlinpolyinfo(F, N, c, eps, [0, 1/4, 1/5, 1/6, 610/4037],
                                  [rbs[1], rbs[2], rbs[3], rbs[4], infinity], false);
            congs := linpolyinfo[1];  Upper := linpolyinfo[2];  Lower := linpolyinfo[3];
            LCM := linpolyinfo[4];    steps := linpolyinfo[5];  sols := linpolyinfo[6];
            linpolys := linpolyinfo[7];
            b2 := applySimp(1, 5, LCM, indices, sols, F, N, c, eps, Lower, Upper, steps,
                                     addressof(SimpTable), addressof(innerTable), true);
            approxresbound := b1[2]*b2[2]*29^(N - 1)/(4325^(N - 1)*4037^(N - 1));
            if approxresbound < 0.999 then
                print("approximate bound on resultant: ",evalf(approxresbound, 10));
                print("Using Lagrange interpolation technique");
                resbound := LagrangeStep(F, N - 1, c,29*x^4 - 58*x^3 + 40*x^2 - 11*x + 1,
                    [[987/4325, b1[2]/4325^(N - 1)],[610/4037, b2[2]/4037^(N - 1)]], eps);
                print("bound on resultant is :",evalf(resbound, 10));
                if resbound < 0.999 then
                    F := F*(29*x^4 - 58*x^3 + 40*x^2 - 11*x + 1); N := N-2; changed:=true
                end if
            end if;
            if not changed then
                print("checking factor (13*x^3-20*x^2+9*x-1)*(13*x^3-19*x^2+8*x-1)");
                innerTable := table();
                SimpTable := table();
                linpolyinfo := getlinpolyinfo(F, N, c, eps, [0, 1/4, 1/5, 1/6,
                    325741/1367481], [rbs[1], rbs[2], rbs[3], rbs[4], infinity], false);
                congs := linpolyinfo[1]; Upper := linpolyinfo[2];  Lower := linpolyinfo[3];
                LCM := linpolyinfo[4];   steps := linpolyinfo[5];  sols := linpolyinfo[6];
                linpolys := linpolyinfo[7];
                b1 := applySimp(1, 5, LCM, indices, sols, F, N, c, eps, Lower, Upper,
                           steps, addressof(SimpTable), addressof(innerTable), true);
                innerTable := table();
                SimpTable := table();
                linpolyinfo := getlinpolyinfo(F, N, c, eps, [0, 1/4, 1/5, 1/6, 11345/63021],
                                         [rbs[1], rbs[2], rbs[3], rbs[4], infinity], false);
                congs := linpolyinfo[1]; Upper := linpolyinfo[2];  Lower := linpolyinfo[3];
                LCM := linpolyinfo[4];   steps := linpolyinfo[5];  sols := linpolyinfo[6];
                linpolys := linpolyinfo[7];
                b2 := applySimp(1, 5, LCM, indices, sols, F, N, c, eps, Lower, Upper,
                           steps, addressof(SimpTable), addressof(innerTable), true);
                innerTable := table();
                SimpTable := table();
                linpolyinfo := getlinpolyinfo(F, N, c, eps, [0, 1/4, 1/5, 1/6,
                       261224/1893085], [rbs[1], rbs[2], rbs[3], rbs[4], infinity], false);
                congs := linpolyinfo[1]; Upper := linpolyinfo[2];  Lower := linpolyinfo[3];
                LCM := linpolyinfo[4];   steps := linpolyinfo[5];  sols := linpolyinfo[6];
                linpolys := linpolyinfo[7];
                b3 := applySimp(1, 5, LCM, indices, sols, F, N, c, eps, Lower, Upper,
                           steps, addressof(SimpTable), addressof(innerTable), true);
                approxresbound := b1[2]*b2[2]*b3[2]*169^(N - 1)/(1367481^(N - 1)
                                                  *63021^(N - 1)*1893085^(N - 1));
                if approxresbound < 0.999 then
                    print("approximate bound on resultant: ",evalf(approxresbound, 10));
                    print("Using Lagrange interpolation technique");
                    resbound := LagrangeStep(F, N - 1, c, (13*x^3 - 20*x^2 + 9*x - 1)
                        *(13*x^3 - 19*x^2 + 8*x - 1), [[325741/1367481,
                        b1[2]/1367481^(N - 1)], [11345/63021, b2[2]/63021^(N - 1)],
                        [261224/1893085, b3[2]/1893085^(N - 1)]], eps);
                    print("bound on resultant is :", evalf(resbound, 10));
                    if resbound < 0.999 then
                        F := F*(13*x^3 - 20*x^2 + 9*x - 1)*(13*x^3 - 19*x^2 + 8*x - 1);
                        N := N - 3; changed := true
                    end if
end if end if;
            if not changed and 11 < N then
                innerTable := table();
                SimpTable := table();
                linpolyinfo := getlinpolyinfo(F, N, c, eps, [0, 1/4, 1/5, 1/6], [rbs[1], rbs[2], rbs[3], rbs[4]], false);
                congs := linpolyinfo[1]; Upper := linpolyinfo[2];  Lower := linpolyinfo[3];
                LCM := linpolyinfo[4];   steps := linpolyinfo[5];  sols := linpolyinfo[6];
                linpolys := linpolyinfo[7]
            end if
        end if;
        if not changed and 11 < N then
            print("final check for x*(1-x)");
            resIs0 := true;
            for ind[2] from Lower[2] to 0 do for ind[3] from Lower[3] to Upper[3] do
                    print("---  ?", ind[2], ind[3], "  ---");
                    newlowup := applySimp(1, 1, LCM, indices, sols, F, N, c, eps,
                         [Lower[1], ind[2], ind[3], Lower[4], seq(Lower[k], k = 5 .. N)],
                         [Upper[1], ind[2], ind[3], Upper[4], seq(Upper[k], k = 5 .. N)],
                         steps, addressof(SimpTable), addressof(innerTable), false);
                    if newlowup <> {} and (newlowup[1] <> 0 or newlowup[2] <> 0)
                    then
                        resIs0 := false; ind[3] := Upper[3]; ind[2] := Upper[2]
                    end if
            end do end do;
            if resIs0 then F := F*x*(1 - x); N := N - 1; changed := true end if;
            if not changed then
                print("final check for 2*x-1");
                resIs0 := true;
                for ind[1] from Lower[1] to 0 do for ind[3] from Lower[3] to Upper[3] do
                        print("---  ", ind[1], "?", ind[3],"  ---");
                        newlowup := applySimp(1, 2, LCM, indices, sols, F, N, c, eps,
                          [ind[1], Lower[2], ind[3], Lower[4], seq(Lower[k], k = 5 .. N)],
                          [ind[1], Upper[2], ind[3], Upper[4], seq(Upper[k], k = 5 .. N)],
                          steps, addressof(SimpTable), addressof(innerTable), false);
                        if newlowup <> {} and (newlowup[1] <> 0 or newlowup[2] <> 0)
                        then
                            resIs0 := false; ind[3] := Upper[3]; ind[1] := Upper[1]
                        end if
end do end do;
                if resIs0 then F := F*(2*x - 1)^2; N := N - 1; changed := true end if
            end if;
            if not changed then
                print("final check for 5*x^2-5*x+1");
                resIs0 := true;
                for ind[1] from Lower[1] to 0 do for ind[2] from Lower[2] to Upper[2] do
                        print("---  ", ind[1], ind[2], "?  ---");
                        newlowup := applySimp(1, 3, LCM, indices, sols, F, N, c, eps,
                          [ind[1], ind[2], Lower[3], Lower[4], seq(Lower[k], k = 5 .. N)],
                          [ind[1], ind[2], Upper[3],Upper[4], seq(Upper[k], k = 5 .. N)],
                          steps, addressof(SimpTable), addressof(innerTable), false);
                        if newlowup <> {} and (newlowup[1] <> 0 or newlowup[2] <> 0)
                        then
                            resIs0 := false; ind[2] := Upper[2]; ind[1] := Upper[1]
                        end if
end do end do;
                if resIs0 then F := F*(5*x^2 - 5*x + 1); N := N - 1; changed := true end if
            end if
end if;
        print(F, N - 1)
    end do;
    if degree(F) < n then
        print([seq(max(abs(Lower[k]), abs(Upper[k])), k = 1 .. min(N, 4))]);
        print("==================================");
        print();

        return branch_and_bound(n, subs(x=t, F), c, 4, (n-degree(F))/2 - 11, 0);
        
end if;
    return F
end proc:





LagrangeStep := proc(F, g, c, critpoly, bounds, eps)
local G, G2, G3, P, RootsOfF, S, a, bound, counter, dG3, fixedx, i, iteration, iterations,
      j, left, middle, minpoints, minpos, minval, points, right, u, val, xvals, xvar;
    iterations := 8;
    Digits := max(degree(F, x) + 2*g, 10);
    u := unapply(1/2 - 1/2*sqrt(1 - 4*x), x);
    if type(F, `+`) then RootsOfF := [fsolve(F, x = 0 .. 1/2)]
    elif type(F, `^`) then RootsOfF := [fsolve(op(1, F), x = 0 .. 1/2)]
    else RootsOfF := [];
         for i to nops(F) do if type(op(i, F), `+`)
             then RootsOfF := [op(RootsOfF), fsolve(op(i, F), x = 0 .. 1/2)]
             else RootsOfF := [op(RootsOfF),fsolve(op(1, op(i, F)), x = 0 .. 1/2)]
         end if end do
    end if;
    RootsOfF := sort([seq(RootsOfF[i]*(1 - RootsOfF[i]), i = 1 .. nops(RootsOfF))]);
    G := 0;
    for i to nops(bounds) do
        P := 1;
        for j to g + 1 do if i <> j then P := P*(x - xv[j])/(xv[i] - xv[j]) end if end do;
        G := G + abs(bounds[i][2]*P)
    end do;
    for i from nops(bounds) + 1 to g + 1 do
        P := 1;
        for j to g + 1 do if i <> j then P := P*(x - xv[j])/(xv[i] - xv[j]) end if end do;
        G := G + abs(c*P/subs(x = u(xv[i]), F))
    end do;
    S := [op(map(x -> x*(1 - x), [fsolve(critpoly, x = 0 .. 1/2)]))];
    a := abs(lcoeff(critpoly, x));
    bound := a^g;
    for j to nops(S) do
        G2 := subs(x = S[j], G);
        xvals := [seq(bounds[i][1], i = 1 .. nops(bounds)),
                  seq(evalf(1/4*k*sqrt(5/6)/(g + 1)), k = nops(bounds) + 1 .. g + 1)];
        for iteration to iterations do for xvar from nops(bounds) + 1 to g + 1 do
                G3 := G2;
                points := {0., op(RootsOfF), evalf(1/4)};
                for fixedx to g + 1 do
                    if fixedx <> xvar then
                        G3 := subs(xv[fixedx] = xvals[fixedx], G3);
                        points := {xvals[fixedx], op(points)}
end if end do;
                points := sort([op(points)]);
                dG3 := diff(G3, xv[xvar]);
                minpoints := [];
                for counter to nops(points) - 1 do
                    left := points[counter];
                    right := points[counter + 1];
                    while 1/10000 < right - left do
                        middle := 1/2*right + 1/2*left;
                        if 0 < evalf(subs(xv[xvar] = middle, dG3))
                            then right := middle else left := middle
                        end if
end do;
                    minpoints := [op(minpoints), middle]
                end do;
                minval := evalf(subs(xv[xvar] = xvals[xvar], G3));
                minpos := xvals[xvar];
                for counter to nops(minpoints) do
                    val := evalf(subs(xv[xvar] = minpoints[counter], G3));
                    if val < minval then
                        minval := val;  minpos := minpoints[counter]
                    end if
                end do;
                xvals[xvar] := minpos;
                if j = nops(S) and bound*minval < 1 - eps then
                    iteration := iterations; xvar := g + 1
                end if
end do end do;
        bound := bound*minval
    end do;
    return bound
end proc:




getlinpolyinfo := proc(F, N, c, eps, Rats, rbounds, addextrapoints)
local n, rats, numextra, u, Rflg, i, j, k, rbound, linpolys, linpolystest, numToVary,
      firstlinpolys, lastlinpolys, G, minsize, testnum, R, sols, thelcms, LCM, E, Mtrx,
      conginfo, minlinpolys, minconginfo, minsols, minLCM, Lower, Upper, congs, steps, gcdi;
    n := N - 1;
    rats := Rats;
    if addextrapoints then numextra := 3 else numextra := 0 end if;
    u := unapply(1/2 - 1/2*sqrt(1 - 4*x), x);
    Rflg := false;
    for i to nops(Rats) do if Rats[i] = 0 then Rflg := true end if end do;
    if not Rflg then rats := [op(rats), 0] end if;
    for i from 4 to 2*N + 2*numextra do for j to floor(1/4*i) do
            if igcd(i, j) = 1 then
                Rflg := false;
                for k to nops(Rats) do
                    if Rats[k] = j/i then Rflg := true end if
                end do;
                if not Rflg then rats := [op(rats), j/i]
                end if
end if end do
    end do;
    for i to nops(rats) do
        try rbound[i] := floor(evalf(denom(rats[i])^n*(c + eps)/abs(subs(x = u(rats[i]), F))))
        catch: rbound[i] := infinity
        end try
    end do;
    linpolys:=[seq([denom(rats[k])*x-numer(rats[k]), rbound[k]], k=nops(Rats)+1..nops(rats))];
    linpolys := sort(linpolys, (a, b) -> a[2] < b[2]);
    linpolys := [seq([denom(rats[k])*x - numer(rats[k]), rbounds[k]],
                 k = 1 .. nops(Rats)),seq(linpolys[k], k = 1 .. nops(linpolys))];
    linpolys := [seq(linpolys[k], k = 1 .. N + numextra)];
    if n < 4 or not addextrapoints then
        linpolystest := [[seq(linpolys[k], k = 1 .. N)]]
    else
        numToVary := min(N - 4, 4, floor(1/2*N));
        firstlinpolys := [seq(linpolys[k], k = 1 .. N - numToVary)];
        lastlinpolys:=combinat[choose]([seq(linpolys[k], k=N-numToVary+1..N+2)], numToVary);
        linpolystest:=[seq([op(firstlinpolys), op(lastlinpolys[k])], k=1..nops(lastlinpolys))]
    end if;
    G := sum(A[kk]*x^kk, kk = 0 .. N - 1);
    minsize := [infinity, infinity];
    for testnum to nops(linpolystest) do
        if n < 4 or not addextrapoints then
            linpolys := linpolystest[1]
        else linpolys := [seq(linpolystest[testnum][k], k = 1 .. 4),
                          op(sort([seq(linpolystest[testnum][k], k = 5 .. N)], (a, b)
                  -> a[2] < b[2] or a[2] = b[2] and coeff(a[1], x) < coeff(b[1], x)))]
        end if;
for i to N do R[i]:=coeff(linpolys[i,1],x,1)^n
                    *subs(x=-coeff(linpolys[i,1],x,0)/coeff(linpolys[i,1],x,1),G)
end do;
sols := solve({seq(R[k] - r[k], k = 1 .. N)},{seq(A[k], k = 0 .. N - 1)});
for i to N do
    thelcms[i] := lcm(seq(denom(op(k, rhs(sols[i]))), k = 1 .. nops(rhs(sols[i]))))
end do;
LCM := lcm(seq(thelcms[k], k = 1 .. N));
E := [];
for i to N do
            if thelcms[i] <> 1 then E := [op(E), rhs(sols[i])*LCM mod LCM] end if
        end do;
        Mtrx := Matrix(nops(E), N);
        for i to nops(E) do for j to N do
                Mtrx[i, j] := coeff(E[i], r[j], 1)
        end do end do;
        conginfo := getCongInfo(Mtrx, nops(E), N, LCM, [seq(linpolys[k, 2], k = 1 .. N)]);
        if conginfo[1][1] < minsize[1]
        or conginfo[1][1] = minsize[1] and conginfo[1][2] < minsize[2] then
            minlinpolys := linpolys;
            minconginfo := conginfo;
            minsols := sols;
            minLCM := LCM;
            minsize := conginfo[1]
        end if
    end do;
    sols := subs(minsols, [seq(A[k], k = 0 .. n)]);
    Lower := minconginfo[2];
    Upper := minconginfo[3];
    congs := minconginfo[4];
    LCM := minLCM;
    steps := [seq(`if`(congs[k] = 0, 1, LCM/congs[k, 1]), k = 1 .. N)];
    for i to N do
        if congs[i] <> 0 then
            gcdi := igcd(congs[i][1], op(congs[i][3]));
            congs[i][1] := congs[i][1]/gcdi;
            congs[i][3] := congs[i][3]/gcdi
end if end do;
    return [congs, Upper, Lower, LCM, steps, sols, minlinpolys]
end proc:





getCongInfo := proc(M, m, n, modulus, bounds)
local D, Mtrx, a, b, col, congs, est, est2, extendsols, gcd, i, j, k, lower,
      maxnum, maxone, p, piv, q, row, s, sols, t, temp, upper, v, val;
    Mtrx := Matrix(m, n);
    for i to m do for j to n do Mtrx[i, j] := M[i, n + 1 - j] end do end do;
    row := 1;
    i := 1;
    while row <= m and i <= n do
        j := row;
        while j <= m and Mtrx[j, i] = 0 do j := j + 1 end do;
        if row < j and j <= m then for col from i to n do
            temp := Mtrx[row, col]; Mtrx[row, col] := Mtrx[j, col]; Mtrx[j, col] := temp
        end do end if;
        if j <= m then
            piv[row] := i;
            j := j + 1;
            while j <= m do
                if Mtrx[j, i] = Mtrx[row, i] then
                    for col from i to n do
                        Mtrx[j, col] := (Mtrx[j, col] - Mtrx[row, col]) mod modulus
                    end do
                elif Mtrx[j, i] <> 0 then
                    gcd := igcdex(Mtrx[row, i], Mtrx[j, i],'s', 't');
                    p := Mtrx[row, i]/gcd;
                    q := Mtrx[j, i]/gcd;
                    for col from i to n do
                        temp := Mtrx[row, col];
                        Mtrx[row, col] := (s*Mtrx[row, col] + t*Mtrx[j, col]) mod modulus;
                        Mtrx[j, col] := (p*Mtrx[j, col] - q*temp) mod modulus
                    end do
                end if;
                j := j + 1
            end do;
            row := row + 1
        end if;
        i := i + 1
    end do;
    for i from row to m do piv[i] := 0 end do;
    for i to m do
        gcd := igcd(seq(Mtrx[i, k], k = 1 .. n));
        if gcd <> 0 then
            s := gcd/igcd(gcd, modulus);
            if s <> 1 then for col to n do
                    Mtrx[i, col] := Mtrx[i, col]/s
                end do
end if end if
    end do;
    for i from 2 to m do
        if piv[i] <> 0 then for j to i - 1 do
                s := round(Mtrx[j, piv[i]]/Mtrx[i, piv[i]]);
                for col from piv[i] to n do
                    Mtrx[j, col] := mods(Mtrx[j, col] - s*Mtrx[i, col], modulus)
                end do
end do end if
    end do;
    congs := [seq(0, i = 1 .. n)];
    for i to m do
        if piv[i] <> 0 then
            a := Mtrx[i, piv[i]];
            gcd := igcdex(a, modulus, 's', 't');
            congs[n + 1 - piv[i]] := [gcd, s, [seq(-Mtrx[i, n + 1 - k], k = 1 .. n - piv[i])]]
end if end do;
    upper := [seq(bounds[k], k = 1 .. n)];
    lower := -upper;
    v := 1;
    est := 0;
    for i to n do
        if upper[i] <> infinity then
            if congs[i] = 0 then
                v := v*(1 + upper[i] - lower[i])
            else v := v*ceil((1 + upper[i] - lower[i])*congs[i][1]/modulus)
            end if;
        end if;
        est := est + v
    end do;
    est2 := 1;
    for i to min(4, floor(1/2*n)) do
        val := (1 + upper[n - i + 1] - lower[n - i + 1])*congs[n - i + 1][1]/modulus;
        est2 := est2*(val - floor(val))^i
    end do;
    return [[est, est2], lower, upper, congs]
end proc:





applySimp := proc(h, i, LCM, indices, sols, F, N, c, eps, Lower, Upper,
                   steps, addressSimpTable, addressinnerTable, justmax)
local FpowerOftwomN, Fv, Maxri, Maxri2sub, Minri, Minri2sub, STval, SimpTable, cnsts,
      cnstsmax, cnstsmin, count, countmax, denomxval, domax, domin, dothismax, dothismin,
      fixedRes, iTsval, iTval, iTwithsub, innerTable, j, jmaxmax, jmaxmin, jminmax, jminmin,
      lastratmaxri, lastratminri, leftside, leftsidemaxmax, leftsidemaxmin, leftsideminmax,
      leftsideminmin, maxri, minri, multiplier, numerxval, numpass, pass, ratmaxri, ratminri,
      subMaxriIniTval, subMinriIniTval, theBound, theBoundval, theBoundval2use, twomN,
      xpowerOftwomN, xv, xval, xvmaxmax, xvmaxmin, xvminmax, xvminmin;
    SimpTable := pointto(addressSimpTable);
    innerTable := pointto(addressinnerTable);
    iTwithsub := table();
    count := 1;
    if Upper[i] = infinity then
        if justmax then countmax := 6 else countmax := infinity end if
    elif N < 10 then countmax := 4
    elif N = 10 then countmax := max(5 - i, 3)
    elif N = 11 then countmax := max(5 - i, 3)
    elif N = 12 then countmax := max(7 - i, 3)
    elif N = 13 then countmax := max(8 - i, 4)
    elif N = 14 then countmax := max(9 - i, 4)
    else countmax := max(N - 4 - i, 5)
    end if;
    fixedRes := {seq(r[k] = indices[k], k = 1 .. h - 1)};
    multiplier := `if`(N < 6, `if`(N < 4, 3, 2), 1);
    twomN := 2*multiplier*N;
    FpowerOftwomN := twomN^degree(F);
    xpowerOftwomN := twomN^(2*N - 2);
    if Digits < 10 then theBound := (c + eps)*LCM*FpowerOftwomN*xpowerOftwomN;
                        theBound := op(1, theBound)*10^op(2, theBound)
    else
        theBound := (c + eps)*LCM*FpowerOftwomN*xpowerOftwomN;
        theBound := evalf(theBound, 5);
        theBound := (op(1, theBound) + 1)*10^op(2, theBound)
    end if;
    for j to multiplier*N do
        xval := j/twomN;
        numerxval := numer(xval);  denomxval := denom(xval);
        STval := SimpTable[numerxval, denomxval];
        if type(STval, name) then
            Fv[j] := subs(x = xval, F)*FpowerOftwomN;
            xv[j] := [seq((xval*(1 - xval))^k*xpowerOftwomN, k = 0 .. N - 1)];
            SimpTable[numerxval, denomxval] := [xv[j], Fv[j], theBound]
        else xv[j] := STval[1]; Fv[j] := STval[2]
        end if;
        iTval := innerTable[numerxval, denomxval];
        if type(iTval, name) then
            iTval := inner(LCM*sols, xv[j])*Fv[j];
            innerTable[numerxval, denomxval] := iTval
        end if;
        iTwithsub[numerxval, denomxval] := subs(fixedRes, iTval)
    end do;
    leftside := [seq(iTwithsub[numer(k/twomN), denom(k/twomN)], k = 1 .. multiplier*N)];
    cnsts := [seq(`if`(k = i or Upper[k] = infinity, NULL, r[k] <= Upper[k]), k = h .. N),
              seq(`if`(k = i or Lower[k] = -infinity, NULL,-r[k] <= -Lower[k]), k = h .. N),
              seq(leftside[k]/theBound <= 1, k = 1 .. multiplier*N),
              seq(-leftside[k]/theBound <= 1, k = 1 .. multiplier*N)];
    cnstsmax := cnsts;
    cnstsmin := cnsts;
    print(N, "  ---  ", time(), "~~~~~~~~~~~~~~~~~~~", Lower[i], Upper[i]);
    domax := true;
    dothismax := true;
    if justmax then domin:=false; dothismin:=false else domin:=true; dothismin:=true end if;
    maxri := infinity;
    ratmaxri := infinity;
    minri := -infinity;
    ratminri := -infinity;
    numpass := 3;
    pass := numpass;
    while domax or domin do
        if pass = 1 then lastratmaxri := ratmaxri end if;
        if dothismax then
            Maxri := simplex[maximize](r[i], cnstsmax);
            if Maxri = {} then print(infeasible); RETURN({}) end if;
            ratmaxri := rhs(op(select(has, Maxri, r[i])));
            maxri := floor(ratmaxri)
        end if;
        if pass = numpass and 2 < count
        and lastratmaxri - maxri < 2*ratmaxri - 2*maxri then domax := false
        end if;
        if pass = 1 then lastratminri := ratminri end if;
        if dothismin then
            Minri := simplex[minimize](r[i], cnstsmin);
            if Minri = {} then print(infeasible); RETURN({}) end if;
            ratminri := rhs(op(select(has, Minri, r[i])));
            minri := ceil(ratminri)
        end if;
        if pass = numpass and 2 < count and minri - lastratminri < 2*minri - 2*ratminri then
            domin := false
        end if;
        if maxri < minri then
            print("no feasible integer points"); RETURN({})
end if;
        if pass = numpass and countmax <= count then
            if countmax < count or 2*lastratmaxri - 2*ratmaxri < steps[i] or N < 15 and 5 < i then
                domax := false
            end if;
            if countmax < count or 2*ratminri - 2*lastratminri < steps[i] or N < 15 and 5 < i then
                domin := false
end if end if;
        if 2 < count and pass = numpass and 4 < i then
            if 4*ratminri - 4*lastratminri < steps[i] then domin := false end if;
            if 4*lastratmaxri - 4*ratmaxri < steps[i] then domax := false end if
        end if;
        if 13 < N and i < 5 and count < 4 then
            domax := true;
            if not justmax then domin := true end if
        end if;
        if justmax then
            if maxri = 0 then domax := false elif count < 3 then domax := true end if
        end if;
        if pass = numpass or justmax and domax = false then
            if justmax then print([evalf(ratmaxri, 8)], time())
            	else print(evalf([ratminri, ratmaxri], 8), time())
end if end if;
if domax or domin then
    if pass = numpass then
        multiplier := 2*multiplier;
        twomN := 2*twomN;
        FpowerOftwomN := FpowerOftwomN*2^degree(F);
        xpowerOftwomN := xpowerOftwomN*2^(2*N - 2);
        theBound := theBound*2^(degree(F) + 2*N - 2);
        if domax then dothismax := true end if;
        if domin then dothismin := true end if
    end if;
    jmaxmax := 0;  jmaxmin := 0;  jminmin := 0;  jminmax := 0;
    Maxri2sub := evalf(Maxri);
    Minri2sub := evalf(Minri);
    for j to multiplier*N do
        xval := j/twomN;
        numerxval := numer(xval);
        denomxval := denom(xval);
        STval := SimpTable[numerxval, denomxval];
        if type(STval, name) then
            Fv := subs(x = xval, F)*FpowerOftwomN;
            xv := [seq((xval*(1 - xval))^k*xpowerOftwomN, k = 0 .. N - 1)];
            theBoundval := theBound;
            SimpTable[numerxval, denomxval] := [xv, Fv, theBoundval]
        else
            xv := STval[1];
            Fv := STval[2];
            theBoundval := STval[3]
        end if;
        iTsval := iTwithsub[numerxval, denomxval];
        if type(iTsval, name) then
            iTval := innerTable[numerxval, denomxval];
            if type(iTval, name) then
                iTval := inner(LCM*sols, xv)*Fv;
                innerTable[numerxval, denomxval] := iTval
            end if;
            iTsval := subs(fixedRes, iTval);
            iTwithsub[numerxval, denomxval] := iTsval
        end if;
        theBoundval2use := theBoundval*(1 - 0.1^floor(Digits/2));
        if dothismax then
            subMaxriIniTval := subs(Maxri2sub, iTsval);
            if theBoundval2use <= subMaxriIniTval then
                jmaxmax := jmaxmax + 1;
                xvmaxmax[jmaxmax] := [xval, theBoundval]
            elif subMaxriIniTval <= -theBoundval2use then
                jmaxmin := jmaxmin + 1;
                xvmaxmin[jmaxmin] := [xval, theBoundval]
end if end if;
                if dothismin then
                    subMinriIniTval := subs(Minri2sub, iTsval);
                    if theBoundval2use <= subMinriIniTval then
                        jminmax := jminmax + 1;
                        xvminmax[jminmax] := [xval, theBoundval]
                    elif subMinriIniTval <= -theBoundval2use then
                        jminmin := jminmin + 1;
                        xvminmin[jminmin] := [xval, theBoundval]
                    end if
end if end do;
            if dothismax or domax and pass = numpass then
                leftsidemaxmax := [seq(iTwithsub[numer(xvmaxmax[k][1]),
                    denom(xvmaxmax[k][1])], k = 1 .. jmaxmax)];
                leftsidemaxmin := [seq(iTwithsub[numer(xvmaxmin[k][1]),
                    denom(xvmaxmin[k][1])], k = 1 .. jmaxmin)];
                if ratmaxri = lastratmaxri then
                    cnstsmax := [op(cnstsmax), seq(leftsidemaxmax[k]/xvmaxmax[k][2] <= 1,
                    k=1..jmaxmax), seq(-1 <= leftsidemaxmin[k]/xvmaxmin[k][2], k=1..jmaxmin)]
                else cnstsmax := [seq(`if`(k = i or Upper[k] = infinity or
                     rhs(op(select(has, Maxri, r[k]))) < Upper[k], NULL, r[k] <= Upper[k]),
                     k=h..N), seq(`if`(k = i or Lower[k] = -infinity or Lower[k]
                     < rhs(op(select(has, Maxri, r[k]))), NULL, -r[k] <= -Lower[k]), k=h..N),
                     seq(leftsidemaxmax[k]/xvmaxmax[k][2] <= 1, k = 1 .. jmaxmax),
                     seq(-1 <= leftsidemaxmin[k]/xvmaxmin[k][2], k = 1 .. jmaxmin)]
end if end if;
            if dothismin or domin and pass = numpass then
                leftsideminmax := [seq(iTwithsub[numer(xvminmax[k][1]),
                    denom(xvminmax[k][1])], k = 1 .. jminmax)];
                leftsideminmin := [seq(iTwithsub[numer(xvminmin[k][1]),
                    denom(xvminmin[k][1])], k = 1 .. jminmin)];
                if ratminri = lastratminri then cnstsmin := [op(cnstsmin),
                    seq(-1 <= leftsideminmin[k]/xvminmin[k][2], k = 1 .. jminmin),
                    seq(leftsideminmax[k]/xvminmax[k][2] <= 1, k = 1 .. jminmax)]
                else cnstsmin := [seq(`if`(k = i or Upper[k] = infinity or
                    rhs(op(select(has, Minri, r[k]))) < Upper[k], NULL, r[k] <= Upper[k]),
                    k=h..N), seq(`if`(k = i or Lower[k] = -infinity or Lower[k]
                    < rhs(op(select(has, Minri, r[k]))), NULL, -r[k] <= -Lower[k]), k=h..N),
                    seq(-1 <= leftsideminmin[k]/xvminmin[k][2], k = 1 .. jminmin),
                    seq(leftsideminmax[k]/xvminmax[k][2] <= 1, k = 1 .. jminmax)]
end if end if;
            if nops(cnstsmax) < N - h + 1 then domax := false end if;
            if nops(cnstsmin) < N - h + 1 then domin := false end if;
            if nops(cnstsmax) <= N - h + 1 then dothismax := false end if;
            if nops(cnstsmin) <= N - h + 1 then dothismin := false end if
        end if;
        pass := pass + 1;
        if numpass < pass then pass := 1 end if;
        if pass = 1 then count := count + 1 end if
    end do;
    maxri := min(maxri, Upper[i]);
    minri := max(minri, Lower[i]);
    if justmax then print([maxri], time()) else print([minri, maxri], time()) end if;
    if maxri < minri then RETURN({}) else RETURN([minri, maxri]) end if
end proc:


# The above code is attributed to Alan Meichsner, 2009
######################################################################################
######################################################################################



branch_and_bound := proc(n, F, c0, branch_num, max_depth, eps)
local nodeQueue, globalUpperBound, best_g_int, num_nodes, node_lower, node, id, var_constrs, g_val,
	g_int, poly, m, branch_ineqs, branch_var_index, new_nodes, i, c_val, nn, degree_G,
	u, F_u, var_lower, var_upper, new_constrs, ineq, ti, g_vals, sup_norm, constrs, G_val;

	Digits := max(240, 2*n);

	u := (1-sqrt(1-4*t))/2;
	F_u := factor(expand(subs(t=u,F)));
	degree_G := (n-degree(F,t))/2;
	print("Degree of polynomial to find: ", degree_G);

	priqueue[initialize](nodeQueue);
	globalUpperBound := c0;
	best_g_int := [];
	num_nodes := 0;

	print("Initializing branch tree...");

	c_val, g_val, constrs := compute_coeffs(n, F, [g[0] = 0], [], 1, globalUpperBound, eps);
	priqueue[insert]([-c_val, [num_nodes+1, [g[0] = 0], constrs, g_val]], nodeQueue);
	num_nodes := num_nodes + 1;

	print("33% done");
	
	c_val, g_val, constrs := compute_coeffs(n, F, [g[0] >= 1], [], 1, globalUpperBound, eps);
	priqueue[insert]([-c_val, [num_nodes+1, [g[0] >= 1], constrs, g_val]], nodeQueue);
	num_nodes := num_nodes + 1;

	print("66% done");
	
	c_val, g_val, constrs := compute_coeffs(n, F, [g[0] <= -1], [], 1, globalUpperBound, eps);
	priqueue[insert]([-c_val, [num_nodes+1, [g[0] <= -1], constrs, g_val]], nodeQueue);
	num_nodes := num_nodes + 1;

	while nodeQueue[0] <> 0 do
		node_lower, node := seq(i, i in priqueue[extract](nodeQueue));
		id, var_constrs, constrs, g_val := node[1], node[2], node[3], node[4];

		print("time: ", time());
		print("memory usage in MB: ", evalf(kernelopts(bytesalloc)/1000000));

		print("Working on node: ", id);
		print("***** Current Lower Bound *****  ", (-node_lower)^(1/n));

		if -node_lower > globalUpperBound then
			print("Cutting branch");
			next;
		end if;

		# Get a solution from the node for a potential upper bound.
		g_int := map(round, g_val);
		poly := add(g_int[i+1]*t^i,i=0..degree_G)*F_u;
		m := maxi(poly);
		if m <= globalUpperBound then
			print("Updating global upper bound to: ", m^(1/n));
			print("This is important so I'm gonna spam now");
			for i to 100 do
				print("*************************************");
			end do;
			print("poly: ", poly);
			print("g_int: ", g_int);
			print("g_val: ", g_val);
			globalUpperBound := m;
			best_g_int := g_int;
		end if;


		

		# Branch, and compute a lower bound for each new node, place valid ones in queue.

		new_nodes := [];
		branch_ineqs := [];
		
		branch_ineqs, var_constrs := selectremove(x -> type(x, `<=`), var_constrs);

		g_vals := [seq(op(2, var_constrs[i]), i=1..nops(var_constrs))];


		branch_var_index := nops(var_constrs);
		if branch_var_index > degree_G then
			next;
		end if;

		var_lower, var_upper := -infinity, infinity;

		# Just try all remaining possibilities using resultant search
		if branch_var_index >= max_depth then
			print("Doing full search with coeffs: ", g_vals);
			ti := time();
			try
				sup_norm, g_int, G_val := full_search(g_vals, n, F, globalUpperBound);
			catch "LP solution failed when initally bounding resultants":
				print("Resultant bounding failed; invalid coefficients");
				next;
			catch "Found bounds contain no integers":
				print("Invalid bounds; invalid coefficients");
				next;
			end try;
			print("Time taken to do full search: ", time()-ti);
			print("Full search gave poly of sup norm: ", sup_norm^(1/n));
			lprint("Found G on interval [0,1]: ", factor(expand(subs(t=t*(1-t), G_val))));
			print("Coeffs: ", g_int);
			if sup_norm < globalUpperBound then
				print("Updating global upper bound to: ", sup_norm^(1/n));
				print("This is important so I'm gonna spam now");
				for i to 100 do
					print("*************************************");
				end do;
				globalUpperBound := sup_norm;
				best_g_int := g_int;
			end if;
			next;
		end if;		

		if branch_var_index = degree_G + 1 then
			var_lower := max(var_lower, 1);
		end if;

		if branch_ineqs <> [] then
			for ineq in branch_ineqs do
				if type(op(1, ineq),'indexed') then
					var_upper := min(var_upper, op(2, ineq));
				elif type(op(2, ineq),'indexed') then
					var_lower := max(var_lower, op(1, ineq));
				end if;
			end do;
		end if;


		if floor(g_val[branch_var_index+1]) = ceil(g_val[branch_var_index+1]) then
			g_val[branch_var_index+1] := g_val[branch_var_index+1] + 0.1;
		end if;
		i := 0;
		while nops(new_nodes) < branch_num - 2 do
			# Create equality branches
			
			if ceil(g_val[branch_var_index+1]+i) > var_upper
					and floor(g_val[branch_var_index+1]-i) < var_lower then
				break;
			end if;

			if ceil(g_val[branch_var_index+1]+i) <= var_upper then	
				new_nodes := [op(new_nodes),
							[num_nodes+1,
							[op(var_constrs),
								g[branch_var_index] = ceil(g_val[branch_var_index+1]+i)],
							[], []]];
				num_nodes := num_nodes + 1;
			end if;
			if floor(g_val[branch_var_index+1]-i) >= var_lower then
				new_nodes := [op(new_nodes),
							[num_nodes+1,
							[op(var_constrs),
								g[branch_var_index] = floor(g_val[branch_var_index+1]-i)],
							[], []]];
				num_nodes := num_nodes + 1;
			end if;
			i := i + 1;
		end do;

		
		# Create inequality branches

		if ceil(g_val[branch_var_index+1]+i) < var_upper then
			new_constrs := [g[branch_var_index] <= var_upper,
							g[branch_var_index] >= ceil(g_val[branch_var_index+1]+i)];
		elif ceil(g_val[branch_var_index+1]+i) = var_upper then
			new_constrs := [g[branch_var_index] = ceil(g_val[branch_var_index+1]+i)];
		else
			new_constrs := NULL;
		end if;

		if new_constrs <> NULL then
			new_nodes := [op(new_nodes),
						[num_nodes+1,
						[op(var_constrs), seq(i, i in new_constrs)],
						[], []]];
			num_nodes := num_nodes + 1;
		end if;

		if floor(g_val[branch_var_index+1]-i) > var_lower then
			new_constrs := [g[branch_var_index] >= var_lower,
							g[branch_var_index] <= floor(g_val[branch_var_index+1]-i)];
		elif floor(g_val[branch_var_index+1]-i) = var_lower then
			new_constrs := [g[branch_var_index] = floor(g_val[branch_var_index+1]-i)];
		else
			new_constrs := NULL;
		end if;

		if new_constrs <> NULL then
			new_nodes := [op(new_nodes),
						[num_nodes+1,
						[op(var_constrs), seq(i, i in new_constrs)],
						[], []]];
			num_nodes := num_nodes + 1;
		end if;


		# Compute lower bound and g_val for each new node and add valid ones to queue
		for i to nops(new_nodes) do
			c_val, g_val, new_constrs := compute_coeffs(n, F, new_nodes[i][2], constrs,
												-node_lower, globalUpperBound, eps);

			new_nodes[i] := [-c_val, new_nodes[i]];
			if c_val > globalUpperBound then
				new_nodes[i] := "Delete me";
				print("Cutting branch");
			else
				new_nodes[i][2][4] := g_val;
				new_nodes[i][2][3] := new_constrs;
			end if;
		end do;

		new_nodes := remove(x -> x = "Delete me", new_nodes);

		for nn in new_nodes do
			priqueue[insert](nn, nodeQueue);
		end do;
		
	end do;

	print("Total nodes: ", num_nodes);

	return best_g_int, globalUpperBound^(1/n);
	
end proc:

compute_coeffs := proc(n, F, bds, constrs, c_val0, cutoff, eps)
local u, F_u, degree_G, G, Q, feas, ti, LPres, vars, c_val, g_val, new_t_vals, i, v, G_val,
	new_constrs, LHS, RHS, G_val_int, c_val_old, return_constrs;

	return_constrs := constrs;

	u := (1-sqrt(1-4*t))/2;
	F_u := factor(expand(subs(t=u,F)));
	degree_G := (n-degree(F,t))/2;
	G := add(g[i]*t^i, i=0..degree_G);
	
	Q := [g[degree_G] >= 1, op(bds)];
	Q := [op(Q), seq(subs(t=v/21, expand(subs(t=t*(1-t), G))) <= c/(abs(subs(t=v/21, F))), v = 1..10),
			seq(subs(t=v/21, expand(subs(t=t*(1-t), G))) >= -c/(abs(subs(t=v/21, F))), v = 1..10)];
	feas := false;

	c_val_old := c_val0;

	while (not feas) do
		ti := time();
		LPres := Optimization[LPSolve](c, Q, iterationlimit = 10000);
		
		vars := LPres[2];
		g_val := [seq(op(2,vars[i]),i=2..nops(vars))];
		
		c_val := LPres[1];
		if abs(c_val - c_val_old) < 0.005 * abs(c_val_old) then
			break;
		end if;
		c_val_old := c_val;

		if c_val > cutoff then
			break;
		end if;
		
		G_val := add(g_val[i+1]*t^i,i=0..degree_G);
		
		new_t_vals := violated_constraints(c_val, G_val, F);

		if new_t_vals = true then
			feas := true;
			print("no new constraints found");
		else
			new_constrs := [];
			for v in new_t_vals do
				LHS := expand((abs(subs(t=v, F)))*subs(t=v, expand(subs(t=t*(1-t), G))));
				RHS := c;
				new_constrs := [op(new_constrs), LHS <= RHS, -RHS <= LHS];
			end do;
			Q := [op(Q), op(new_constrs)];
			return_constrs := [op(return_constrs), op(new_constrs)];
		end if;
	end do;

	return c_val, g_val, return_constrs;
	
end proc:

violated_constraints := proc(c_val, G_val, F)
local invalid_t_vals, poly, vals, LHS, RHS, v, eps, locals, sorted_locals, highest_peaks;

	eps := c_val*10^(-4);

	invalid_t_vals := [];
	poly := expand(subs(t=t*(1-t), G_val))*F;
	vals := local_maxi(poly);

	locals := convert(vals, 'list');
	sorted_locals := sort(locals, (a, b) ->
			evalb(abs(subs(t = b, poly))^(1/degree(poly, t))
				<= abs(subs(t = a, poly))^(1/degree(poly, t))));
	highest_peaks := sorted_locals[1 .. min(12, nops(sorted_locals))];


	for v in highest_peaks do
		
		if abs(subs(t=v,poly)) > c_val + eps then
			invalid_t_vals := [op(invalid_t_vals), v];
		end if;
	end do;

	if nops(invalid_t_vals) = 0 then
		return true;
	else
		return invalid_t_vals;
	end if;

end proc:


full_search := proc(g_vals_input, n, F_input, c_val)
local u, F_u, degree_G, r_bds, lin_poly_roots, v, eqns, vars, rat_combs, j, LCM, cof, M, bounds,
	Mtrx, terms, i, var, prod, num_roots, best_est, est_iters, best_Mtrx, best_M, best_rat_combs,
	best_lin_poly_roots, best_r_bds, lin_poly_roots_core, lpr_last_index, num_last_roots,
	all_bounds, all_lin_poly_roots, all_lin_poly_roots_der, lin_poly_ders, lpr, der, m, all_g_vals,
	all_lin_poly_ders, best_lin_poly_ders, a, ti, step_sizes, g_vals, F, G_val, bd;
	
	Digits := 80;

	F := F_input;
	g_vals := g_vals_input;
	while nops(g_vals) > 0 and g_vals[1] = 0 do
		g_vals := g_vals[2..-1];
		F := F*t*(1-t);
	end do;
	
	u := (1-sqrt(1-4*t))*(1/2);
	F_u := factor(expand(subs(t = u, F)));
	degree_G := (n-degree(F,t))/2;
	print("Degree of polynomial G to do full search on: ", degree_G);

	num_roots := degree_G+1-nops(g_vals);
	all_lin_poly_roots_der, all_bounds := create_lin_polys(num_roots + 50, num_roots + 5,
													g_vals, n, F, c_val);

	all_lin_poly_roots := [seq(all_lin_poly_roots_der[i][1], i=1..nops(all_lin_poly_roots_der))];
	all_lin_poly_ders := [seq(all_lin_poly_roots_der[i][2], i=1..nops(all_lin_poly_roots_der))];

	num_last_roots := min(num_roots, 5);

	lin_poly_roots_core := all_lin_poly_roots[1..num_roots-num_last_roots];

	best_est := infinity;

	for lpr_last_index in combinat[choose]([seq(num_roots-num_last_roots+1 .. num_roots+5)],
									num_last_roots) do

		lin_poly_roots := [op(lin_poly_roots_core), op(all_lin_poly_roots[lpr_last_index])];

		bounds := [op(all_bounds[1..nops(lin_poly_roots_core)]), op(all_bounds[lpr_last_index])];
		lin_poly_ders := [op(all_lin_poly_ders[1..nops(lin_poly_roots_core)]),
						op(all_lin_poly_ders[lpr_last_index])];
					
		r_bds := [seq([ceil(bounds[i][1]), floor(bounds[i][2])], i=1..nops(bounds))];
		for bd in r_bds do
			if bd[2] < bd[1] then
				error "Found bounds contain no integers";
			end if;
		end do;
	
		v := [seq(denom(lin_poly_roots[i]), i=1..nops(lin_poly_roots))];

		eqns := [];
		for i to nops(lin_poly_roots) do
			lpr := lin_poly_roots[i];
			der := lin_poly_ders[i];
			
			eqns := [op(eqns), r[i] =
					v[i]^(degree_G-der)*add(mul(k-1+nops(g_vals)-j, j=0..der-1)
									*g[k-1+nops(g_vals)]*lpr^(k-1+nops(g_vals)-der),
														k=1..nops(lin_poly_roots))];
		end do;
		vars := [seq(g[i+nops(g_vals)], i=0..nops(lin_poly_roots)-1)];
	
		rat_combs := solve(eqns, vars)[1];	
	
		LCM := [];
	
		for j to nops(rat_combs) do
			rat_combs[j] := op(2, rat_combs[j]);
			cof := [coeffs(rat_combs[j])];
			LCM := [op(LCM), lcm(seq(`if`(type(cof[i], 'fraction'), op(2, cof[i]), NULL),
					i=1..nops(cof)))];
		end do;
	
		M := lcm(seq(i, i in LCM));
		Mtrx := Matrix(nops(rat_combs), nops(rat_combs));
	
		for j to nops(rat_combs) do
			terms := [op(rat_combs[j])];
			for i to nops(terms) do
				cof := coeffs(terms[i]);
				var := op(indets(terms[i])[1]);
				Mtrx[j, op(var)] := M * cof;
			end do;
		end do;
	
		Mtrx := EEAreduce(Mtrx, nops(rat_combs), nops(rat_combs), M);

		est_iters := 0;
		prod := 1;
		for i from 1 to nops(rat_combs) do
			prod := prod * (r_bds[i][2]-r_bds[i][1]+1)*gcd(Mtrx[-i,-i], M)/M;
			#print(prod);
			est_iters := est_iters + prod; 
		end do;

		if est_iters < best_est then
			best_est := est_iters;
			best_Mtrx := Mtrx;
			best_M := M;
			best_rat_combs := rat_combs;
			best_lin_poly_roots := lin_poly_roots;
			best_lin_poly_ders := lin_poly_ders;
			best_r_bds := r_bds;
		end if;
		
	end do;
	
	step_sizes := [seq(best_M/gcd(best_M, best_Mtrx[num_roots-k,num_roots-k]), k=0..num_roots-1)];
	
	print("best Mtrx quality: ", evalf(best_est));

	ti := time();
	
	m, all_g_vals := backsub_search(best_Mtrx, best_M, best_rat_combs, best_lin_poly_roots,
								best_r_bds, n, F, g_vals, [], c_val);
	print("backsub search time: ", time()-ti);
	all_g_vals := [op(g_vals_input[1..nops(g_vals_input)-nops(g_vals)]), op(all_g_vals)];
	G_val := add(all_g_vals[i+1]*t^i, i=0..nops(all_g_vals)-1);
	return m, all_g_vals, factor(G_val);
	
end proc:

create_lin_polys := proc(num_polys, return_num_polys, g_vals, n, F, c_val)
local lin_poly_roots_der, i, j, u, F_u, degree_G, k, bounds, bound, bound_sizes, lpr, offset,
		sort_perm, alt_bound, lprd, der;
	u := (1-sqrt(1-4*t))*(1/2);         
	F_u := factor(expand(subs(t = u, F)));
	degree_G := (n-degree(F,t))/2;
	
	lin_poly_roots_der := [];
	i := 4;
	j := 1;
	while nops(lin_poly_roots_der) < num_polys do
		if igcd(i,j) = 1 then
			lin_poly_roots_der := [op(lin_poly_roots_der), [j/i,0]];
		end if;
		if j + 1 > i/4 then
			j := 1;
			i := i+1;
		else
			j := j + 1;
		end if;
	end do;
	bound_sizes := [];
	bounds := [];
	for lprd in lin_poly_roots_der do
		lpr := lprd[1];
		der := lprd[2];
		if subs(t=lpr, F_u) = 0 or der > 0 then
			try
				alt_bound := bound_res([lpr], der, g_vals, [], [], n, F, c_val, 1, 100);
			catch "no feasible solution found":
				error "LP solution failed when initally bounding resultants";
			end try;
			bounds := [op(bounds), alt_bound];
			bound_sizes := [op(bound_sizes), alt_bound[2]-alt_bound[1]];
		else
			bound := (denom(lpr)^degree_G)*c_val/abs(evalf(subs(t=lpr,F_u)));
			offset := -denom(lpr)^degree_G*add(g_vals[k]*lpr^(k-1), k=1..nops(g_vals));
			bounds := [op(bounds), [-bound + offset, bound + offset]];
			bound_sizes := [op(bound_sizes), 2*bound];
		end if;
	end do;
	sort_perm := sort_permutation(bound_sizes);
	lin_poly_roots_der := lin_poly_roots_der[sort_perm];
	bounds := bounds[sort_perm];

	lin_poly_roots_der := lin_poly_roots_der[1..return_num_polys];
	bounds := bounds[1..return_num_polys];
	
	for i to nops(lin_poly_roots_der) do
		lpr := lin_poly_roots_der[i][1];
		der := lin_poly_roots_der[i][2];
		if subs(t=lpr, F_u) <> 0 then
			bound := bounds[i];
			try
				alt_bound := bound_res([lpr], der, g_vals, [], [], n, F, c_val, 1, 100);
			catch "no feasible solution found":
				error "LP solution failed when initally bounding resultants";
			end try;
			if alt_bound[2]-alt_bound[1] < bound[2]-bound[1] then
				bounds[i] := alt_bound;
			end if;
		end if;
	end do;
	
	return lin_poly_roots_der, bounds;
end proc:

sort_permutation := proc(l)
local sorted, perm, k, item;
	sorted := sort(l);
	perm := [];
	for item in sorted do
		member(item, l, 'k');
		perm := [op(perm), k];
	end do;
	return perm;
end proc:

backsub_search := proc(Mtrx, modulus, rat_combs, lin_poly_roots, r_bds, n, F,
					g_vals, current_rs, c_val)
local degree_G, u, F_u, new_rs, row_index, row, r_vals, new_g_vals, G_val, poly, cong_solns,
	all_g_vals, j, max_vals, min_sup, best_gs, res, i, rs, next_r, GCD, mod_eqn, new_r_bds, new_r_bd,
	new_lower, new_upper, interval_size;
	userinfo(3,backsub_search, "current_rs", current_rs);
	degree_G := (n-degree(F,t))/2;
	if nops(current_rs) = op(1, Mtrx)[1] then
		u := (1-sqrt(1-4*t))*(1/2);         
		F_u := factor(expand(subs(t = u, F)));
		
		#compute r values from given g_vals and from chosen current_rs
		r_vals := current_rs;
		userinfo(3,backsub_search, "r_vals", r_vals);
		userinfo(3,backsub_search, "r_bd sizes", seq(r_bds[i][2]-r_bds[i][1], i=1..nops(r_bds)));
		#compute new g_vals from r values to add to given g_vals
		new_g_vals := [seq(subs(seq(r[i]=r_vals[i], i=1..nops(r_vals)), rat_combs[j]),
															j=1..nops(rat_combs))];
		all_g_vals := [op(g_vals), op(new_g_vals)];

		G_val := add(all_g_vals[i+1]*t^i, i=0..degree_G);
		poly := G_val*F_u;
		if poly = 0 then
			return 1, [];
		end if;
		return maxi(poly), all_g_vals;
	else
		min_sup := 1;
		best_gs := [];
		row_index := op(1, Mtrx)[1] - nops(current_rs);
		row := Mtrx[row_index];

		GCD := gcd(modulus, row[row_index]);

		if add(row[i+row_index+1]*current_rs[nops(current_rs)-i],
				i = 0..nops(current_rs)-1) mod GCD <> 0 then
			print("NO SOLUTION TO CONGRUENCE");
			return 1, [];
		end if;

		interval_size := r_bds[nops(current_rs)+1][2]-r_bds[nops(current_rs)+1][1] + 1;

		new_r_bds := r_bds;

		userinfo(3,backsub_search,"interval_size * GCD / modulus",interval_size * GCD / modulus);
		
		if row[row_index] = 0 then
			
			for i from new_r_bds[nops(current_rs)+1][1] to new_r_bds[nops(current_rs)+1][2] do
				rs := [op(current_rs), i];
				userinfo(3,backsub_search, "rs", rs);
				userinfo(3,backsub_search, "r_bd sizes", seq(new_r_bds[i][2]-new_r_bds[i][1],
															i=1..nops(new_r_bds)));
				userinfo(3,backsub_search, "********");
				try
					res := backsub_search(Mtrx, modulus, rat_combs, lin_poly_roots,
										new_r_bds, n, F, g_vals, rs, c_val);
					if res[1] < min_sup then
						min_sup := res[1];
						best_gs := res[2];
					end if;
				catch "no feasible solution found":
				end try;
			end do;
		else
			mod_eqn := add(row[i+row_index+1]*current_rs[nops(current_rs)-i],
							i = 0..nops(current_rs)-1)/GCD + (row[row_index]/GCD)*r = 0;
			cong_solns := [msolve(mod_eqn, modulus/GCD)];
			userinfo(3,backsub_search, "cong_solns", cong_solns);
			userinfo(3,backsub_search,"new_r_bds[nops(current_rs)+1][1]: ",
									new_r_bds[nops(current_rs)+1][1]);
			userinfo(3,backsub_search,"new_r_bds[nops(current_rs)+1][2]: ",
									new_r_bds[nops(current_rs)+1][2]);
			new_rs := [seq(op(2, cong_solns[i][1]), i = 1..nops(cong_solns))];
			userinfo(3,backsub_search, "new_rs", new_rs);
			
			for j from floor(new_r_bds[nops(current_rs)+1][1]/(modulus/GCD)) to
						ceil(new_r_bds[nops(current_rs)+1][2]/(modulus/GCD)) do
				userinfo(3,backsub_search, "j", j);
				for i to nops(new_rs) do
					next_r := new_rs[i]+j*(modulus/GCD);
					userinfo(3,backsub_search, "next_r", next_r);
					if next_r >= new_r_bds[nops(current_rs)+1][1] and
							next_r <= new_r_bds[nops(current_rs)+1][2] then
						userinfo(3,backsub_search, "valid next_r", next_r);
						rs := [op(current_rs), next_r];
						userinfo(3,backsub_search, "rs", rs);
						userinfo(3,backsub_search, "r_bd sizes",
									seq(new_r_bds[i][2]-new_r_bds[i][1],
														i=1..nops(new_r_bds)));
						userinfo(3,backsub_search, "********");
						try
							res := backsub_search(Mtrx, modulus, rat_combs, lin_poly_roots,
												new_r_bds, n, F, g_vals, rs, c_val);
							if res[1] < min_sup then
								min_sup := res[1];
								best_gs := res[2];
							end if;
						catch "no feasible solution found":
						end try;
					end if;
				end do;
			end do;
		end if;
		return min_sup, best_gs;
	end if;
end proc:

bound_res := proc(lin_poly_roots, num_diffs, g_vals, current_rs, r_bds,
					n, F, c_val, num_iters, num_init_constrs)
local degree_G, u, F_u, init_constrs, G, r_idx, obj, v, res_constrs, constrs, LPres_min, LPres_max,
		lower, upper, old_constrs_max, old_constrs_min, iter, new_g_vals_max, den,
		new_g_vals_min, G_val_max, G_val_min, new_t_max, new_t_min, new_constrs_max,
		new_constrs_min, constrs_max, constrs_min, domax, domin, int_r_bds, res_bds;

	if nops(lin_poly_roots) < nops(current_rs)+1 then
		error "incorrect number of roots provided for bounding with given current_rs";
	end if;
	
	degree_G := (n-degree(F,t))/2;
	u := (1-sqrt(1-4*t))*(1/2);         
	F_u := factor(expand(subs(t = u, F)));
	G := subs(seq(g[j-1]=g_vals[j], j=1..nops(g_vals)), add(g[i]*t^i, i=0..degree_G));
	r_idx := nops(current_rs)+1;
	v := [seq(denom(lin_poly_roots[i]), i=1..nops(lin_poly_roots))];

	den := num_init_constrs*2 + 1;

	obj := (v[r_idx]^(degree_G-num_diffs)) * add(mul(k-i, i=0..num_diffs-1)
								    		*g[k]*lin_poly_roots[r_idx]^(k-num_diffs),
											k=max(num_diffs, nops(g_vals))..degree_G);
	init_constrs := [seq(subs(t=val/den, G) <= c_val/(abs(subs(t=val/den, F_u))),
														val = 1..num_init_constrs/2),
					seq(subs(t=val/den, G) >= -c_val/(abs(subs(t=val/den, F_u))),
														val = 1..num_init_constrs/2)];
	res_constrs := [seq(current_rs[l] = (v[l]^degree_G)*add(g[k]*lin_poly_roots[l]^k,
									k=nops(g_vals)..degree_G), l=1..r_idx-1)];
	constrs := [op(init_constrs), op(res_constrs)];
	LPres_min := Optimization[LPSolve](obj, constrs);
	LPres_max := Optimization[LPSolve](obj, constrs, 'maximize');
	upper := LPres_max[1];
	lower := LPres_min[1];

	
	old_constrs_max := res_constrs;
	old_constrs_min := res_constrs;
	iter := 1;
	domax := true;
	domin := true;
	while floor(upper) - ceil(lower) <> 0 and iter < num_iters and (domax or domin) do
		iter := iter + 1;

		if domax then
			new_g_vals_max := LPres_max[2];
			G_val_max := subs(new_g_vals_max, G);
			new_t_max := violated_constraints(c_val, G_val_max, F_u);
			if new_t_max = true then
				domax := false;
			else
				new_constrs_max := [seq(subs(t=val, G)<=c_val/(abs(subs(t=val, F_u))),
																val in new_t_max),
								seq(subs(t=val, G)>=-c_val/(abs(subs(t=val, F_u))),
																val in new_t_max)];
				constrs_max := [op(init_constrs), op(old_constrs_max), op(new_constrs_max)];
				old_constrs_max := [op(old_constrs_max), op(new_constrs_max)];
				LPres_max := Optimization[LPSolve](obj, constrs_max, 'maximize');
				upper := LPres_max[1];
			end if;
		end if;
		if domin then
			new_g_vals_min := LPres_min[2];
			G_val_min := subs(new_g_vals_min, G);
			new_t_min := violated_constraints(c_val, G_val_min, F_u);
			if new_t_min = true then
				domin := false;
			else
				new_constrs_min := [seq(subs(t=val, G)<=c_val/(abs(subs(t=val, F_u))),
																val in new_t_min),
								seq(subs(t=val, G)>=-c_val/(abs(subs(t=val, F_u))),
																val in new_t_min)];
				constrs_min := [op(init_constrs), op(old_constrs_min), op(new_constrs_min)];
				old_constrs_min := [op(old_constrs_min), op(new_constrs_min)];
				LPres_min := Optimization[LPSolve](obj, constrs_min);
				lower := LPres_min[1];
			end if;
		end if;
	end do;
	
	return [lower, upper];
end proc:


# The contents of this procedure are credited to Alan Meichsner
EEAreduce := proc(M, m, n, modulus)
local i, j, row, col, temp, gcd, p, q, s, Mtrx;
	Mtrx := Matrix(m, n);
	for i to m do for j to n do Mtrx[i, j] := M[i, n + 1 - j] mod modulus; end do end do;
	row := 1;
	i := 1;
	while row <= m and i <= n do
		j := row;
		while j <= m and Mtrx[j, i] = 0 do
			j := j + 1;
		end do;
		if row < j and j <= m then
			for col from i to n do
				temp := Mtrx[row, col];
				Mtrx[row, col] := Mtrx[j, col];
				Mtrx[j, col] := temp;
			end do;
		end if;
		if j <= m then
			j := j + 1;
			while j <= m do
				if Mtrx[j, i] = Mtrx[row, i] then
					for col from i to n do
						Mtrx[j, col] := (Mtrx[j, col] - Mtrx[row, col]) mod modulus
					end do;
				elif Mtrx[j, i] <> 0 then
					gcd := igcdex(Mtrx[row, i], Mtrx[j, i],'s_val', 't_val');
					p := Mtrx[row, i]/gcd;
					q := Mtrx[j, i]/gcd;
					for col from i to n do
						temp := Mtrx[row, col];
						Mtrx[row, col] :=
							(s_val*Mtrx[row, col] + t_val*Mtrx[j, col]) mod modulus;
						Mtrx[j, col] := (p*Mtrx[j, col] - q*temp) mod modulus
					end do;
				end if;
				j := j + 1
			end do;
			row := row + 1
		end if;
		i := i + 1
	end do;
	for i to m do
		gcd := igcd(seq(Mtrx[i, k], k = 1 .. n));
		if gcd <> 0 then
			s := gcd/igcd(gcd, modulus);
			if s <> 1 then
				for col to n do
					Mtrx[i, col] := Mtrx[i, col]/s
				end do;
			end if;
		end if;
	end do;
	return Mtrx;
end proc:



local_maxi := proc(p)
local i, j, m, poly, poly2, v, v2, vals;
	if type(p, `+`) then poly := diff(p, t);
	else
		poly := 0;
		for i to nops(p) do
			poly2 := 1;
			for j to nops(p) do
				if i = j then
					if type(op(j, p), `^`) then
						poly2 := poly2 * diff(op(1, op(j, p)), t) * op(2, op(j, p));
					else
						poly2 := poly2 * diff(op(j, p), t);
					end if;
				else
					if type(op(j, p), `^`) then
						poly2 := poly2 * op(1, op(j, p));
					else
						poly2 := poly2 * op(j, p);
					end if;
				end if;
			end do;
			poly := poly + poly2;
		end do;
	end if;
	vals := {0, 0.5, fsolve(poly, t = 0 .. 0.5)};
	return vals;
end proc:

maxi := proc(p)
local i, j, m, poly, poly2, v, v2, vals, r, polyset;
	if type(p, `+`) or type(p, `^`) then
		poly := diff(p, t);
		vals := {0, 0.25, fsolve(poly, t = 0 ..0.25)};
		m := 0;
		for v in vals do
			v2 := abs(subs(t=v, p));
			if m < v2 then m := v2 end if
		end do;
		return m;
	else
		polyset := [seq(`if`(type(op(i, p), `^`), op(1, op(i, p)), op(i, p)), i = 1..nops(p))];
		poly := 0;
		for i to nops(p) do
			
			if type(op(i, p), `^`) then
				r[i] := op(2, op(i, p));
			else
				r[i] := 1;
			end if;
			
			poly2 := 1;
			for j to nops(p) do
				if i = j then
					if type(op(j, p), `^`) then
						poly2 := poly2 * diff(op(1, op(j, p)), t) * op(2, op(j, p));
					else
						poly2 := poly2 * diff(op(j, p), t);
					end if;
				else
					if type(op(j, p), `^`) then
						poly2 := poly2 * op(1, op(j, p));
					else
						poly2 := poly2 * op(j, p);
					end if;
				end if;
			end do;
			poly := poly + poly2;
		end do;
	end if;
	vals := {0.25, fsolve(poly, t = 0 ..0.25)};
	m := 0;
	for v in vals do
		v2 := evalf(exp(add(r[i]*log(abs(subs(t = v, polyset[i]))), i = 1..nops(polyset))));
		if m < v2 then m := v2 end if
	end do;
	return m;
end proc:
interface(displayprecision = 20);
kernelopts(printbytes = false);
interface(rtablesize = 20);
n := 147;
c_val := 2.348766^(-n);
intCheb(1, n, c_val);
tracelast;

